﻿Imports System.Windows.Forms.DataVisualization.Charting

Public Class Form1
    Dim data_path As String = System.AppDomain.CurrentDomain.BaseDirectory & "data\"
    Dim out_file As System.IO.StreamWriter
    Dim Ymax As Integer

    Dim date_from1 As Date  ' 表示期間開始日（左側のカレンダー）
    Dim date_to1 As Date    ' 表示期間終了日（左側のカレンダー）
    Dim date_from2 As Date  ' 表示期間開始日（右側のカレンダー　比較用）
    Dim date_to2 As Date    ' 表示期間終了日（右側のカレンダー　比較用）

    '----------------------------------------------------------------------------
    ' リアルタイム表示プログラムが蓄積したファイルを日付毎に分割保存
    '
    ' 入力ファイル：raw.txt（リアルタイム表示プログラムが蓄積したファイル）
    '　　　　　　　　入力ファイルはbackuフォルダーにリネームされ移動
    ' 出力ファイル：日付.txt
    '----------------------------------------------------------------------------
    Private Sub process_raw()
        Dim dt As New DataTable
        Dim raw_file As FileIO.TextFieldParser
        Dim buf() As String
        Dim rdate As Date

        Dim out_fname_date As String = ""
        Dim out_fname As String = ""
        Dim date_str As String
        Dim out_file_opened As Boolean = False
        Dim fname = data_path + "raw.txt"

        If Not System.IO.File.Exists(fname) Then
            MsgBox("ファイルは存在しません" & vbCr & "既に読み込み済みです", vbExclamation, "ERROR")
            Exit Sub
        End If

        If is_writeable(fname) = False Then
            MsgBox("ファイルは他のプログラムが使用中です" & vbCr & "モニターを停止させてから操作して下さい", vbExclamation, "ERROR")
            Exit Sub
        End If
        raw_file = My.Computer.FileSystem.OpenTextFieldParser(fname, ",")
        While Not raw_file.EndOfData
            buf = raw_file.ReadFields
            If Mid(buf(0), 1, 1) <> "@" Then
                rdate = Date.Parse(buf(3))
                buf(3) = rdate.ToString("yyyy/MM/dd HH:mm:ss")
                date_str = Mid(buf(3), 1, 10)
                If out_fname_date <> date_str Then
                    If out_file_opened Then
                        out_file.Flush()
                        out_file.Close()
                        compress(out_fname)
                    End If
                    out_fname_date = date_str
                    out_fname = data_path & Replace(out_fname_date, "/", "") & ".txt"
                    out_file = My.Computer.FileSystem.OpenTextFileWriter(out_fname, True)
                    out_file_opened = True
                End If
                out_file.WriteLine(buf(0) & "," & buf(1) & "," & buf(2) & "," & buf(3))
            End If
        End While
        raw_file.Close()
        out_file.Flush()
        out_file.Close()
        compress(out_fname)

        raw_file.Dispose()
        Dim fname_moveto As String = data_path & "backup\raw" & System.DateTime.Now.ToString("yyyyMMdd-HHmmss") & ".txt"
        Try
            My.Computer.FileSystem.MoveFile(fname, fname_moveto)
        Catch ex As Exception
            MsgBox("ファイルが移動できなかった" & vbCr & "from:" & fname & vbCr & "to:" & fname_moveto, vbExclamation, "ERROR")
        End Try
    End Sub

    '----------------------------------------------------------------------------
    ' グラフ表示高速化のため
    ' ２秒間隔データのTXTファイルを１時間単位に集計して.txt2ファイルとして保存
    '----------------------------------------------------------------------------
    Public Sub compress(fname As String)
        Dim fd_in As FileIO.TextFieldParser
        Dim fd_out As System.IO.StreamWriter
        Dim buf_in As String()
        Dim hour As String
        Dim records As Integer
        Dim sum1 As Double
        Dim sum2 As Double

        hour = "00"
        records = 0
        sum1 = 0
        sum2 = 0
        fd_in = My.Computer.FileSystem.OpenTextFieldParser(fname, ",")
        fd_out = My.Computer.FileSystem.OpenTextFileWriter(fname & "2", False)
        While Not fd_in.EndOfData
            buf_in = fd_in.ReadFields
            If (hour <> Mid(buf_in(3), 12, 2)) Or fd_in.EndOfData Then
                If records <> 0 Then
                    fd_out.WriteLine("0" & "," & Int(sum1 / records).ToString & "," & Int(sum2 / records).ToString & "," _
                   & Mid(buf_in(3), 1, 11) & hour & ":00:00")
                End If
                hour = Mid(buf_in(3), 12, 2)
                records = 0
                sum1 = 0
                sum2 = 0
            Else
                sum1 = sum1 + buf_in(1)
                sum2 = sum2 + buf_in(2)
                records = records + 1
            End If
        End While
        fd_in.Close()
        fd_out.Close()
    End Sub

    '----------------------------------------------------------------------------
    ' ファイル書き込み可能か否かのチェック
    '----------------------------------------------------------------------------
    Private Function is_writeable(fname As String)
        Try
            Dim fd = My.Computer.FileSystem.OpenTextFileWriter(fname, True)
            fd.Close()
        Catch ex As Exception
            Return False
        End Try

        Return True
    End Function

    '----------------------------------------------------------------------------
    ' グラフ描画の親ルーチン
    '    親：display_graph() --- 子：draw_series() --- 孫：draw_point()
    '----------------------------------------------------------------------------
    Private Sub display_graph()
        Label_peakcount.Text = "ピーク数:"  ' ピーク数表示ボタンを押した結果をクリヤしておく
        If CheckBox_compare.Checked = False Then
            Chart1.Series(0).ChartType = SeriesChartType.StackedArea
            Chart1.Series(1).ChartType = SeriesChartType.StackedArea
            If CheckBox_swap.Checked Then
                Chart1.Series(0).Color = Color.DodgerBlue
                Chart1.Series(1).Color = Color.Orange
                SplitContainer1.Panel1.BackColor = Color.DodgerBlue
                SplitContainer1.Panel2.BackColor = Color.Orange
            Else
                Chart1.Series(0).Color = Color.Orange
                Chart1.Series(1).Color = Color.DodgerBlue
                SplitContainer1.Panel1.BackColor = Color.Orange
                SplitContainer1.Panel2.BackColor = Color.DodgerBlue
            End If
        Else
            If CheckBox_ch_add.Checked Then
                SplitContainer1.Panel1.BackColor = Color.Orange
                SplitContainer1.Panel2.BackColor = Color.Orange
                SplitContainer2.Panel1.BackColor = Color.Crimson
                SplitContainer2.Panel2.BackColor = Color.Crimson
            Else
                SplitContainer1.Panel1.BackColor = Color.Orange
                SplitContainer1.Panel2.BackColor = Color.DodgerBlue
                SplitContainer2.Panel1.BackColor = Color.Crimson
                SplitContainer2.Panel2.BackColor = Color.DarkGreen
            End If
            Chart1.Series(0).Color = Color.Orange
            Chart1.Series(1).Color = Color.DodgerBlue
            Chart1.Series(2).Color = Color.Crimson
            Chart1.Series(3).Color = Color.DarkGreen
            Chart1.Series(0).ChartType = SeriesChartType.Line
            Chart1.Series(1).ChartType = SeriesChartType.Line
            Chart1.Series(2).ChartType = SeriesChartType.Line
            Chart1.Series(3).ChartType = SeriesChartType.Line
        End If

        If RadioButton_month.Checked Then
            If CheckBox_compare.Checked Then
                Chart1.Series(0).ChartType = SeriesChartType.Column
                Chart1.Series(1).ChartType = SeriesChartType.Column
                Chart1.Series(2).ChartType = SeriesChartType.Column
                Chart1.Series(3).ChartType = SeriesChartType.Column
            Else
                Chart1.Series(0).ChartType = SeriesChartType.StackedColumn
                Chart1.Series(1).ChartType = SeriesChartType.StackedColumn
                Chart1.Series(2).ChartType = SeriesChartType.StackedColumn
                Chart1.Series(3).ChartType = SeriesChartType.StackedColumn
            End If
        End If

        If CheckBox_fixedY.Checked Then
            Chart1.ChartAreas(0).AxisY.Maximum = Ymax
        End If

        draw_series(0)
        If CheckBox_compare.Checked And date_from1 <> date_from2 Then
            draw_series(1)
        End If
    End Sub

    '----------------------------------------------------------------------------
    ' ピーク値散布図を表示する
    ' 折れ線グラフはこれを実行する前に draw_series() で描画しておく
    ' 計測したデータは消費電力なので電力[W]=電流[A]×100[V]で換算している
    '
    ' 引数
    ' 　s_type - グラフの表示範囲　年:YEAR 月:MONTH 週:WEEK 日:DAY 時刻:HOUR
    '   amp - 電流値
    '   sec - 継続時間
    '   date_from,date_to - 表示期間
    '----------------------------------------------------------------------------
    Private Sub draw_peak()
        Dim buf() As String
        Dim ch As Long
        Dim date_step As New TimeSpan(1, 0, 0, 0)
        Dim peak_find As Boolean = False
        Dim peak_find_prev As Boolean = False
        Dim peak_seconds As Integer = 0
        Dim sum As Double = 0
        Dim num_peak As Integer = 0
        Dim idx As Integer

        Dim amp As Integer = TrackBar_amp.Value
        Dim sec As Integer = TrackBar_time.Value

        Label_peakcount.Text = ""
        Chart1.Series(4).Points.Clear()
        Application.DoEvents()

        Dim graph_x_span As Double
        graph_x_span = Chart1.ChartAreas.FindByName("ChartArea1").AxisX.Maximum
        ProgressBar1.Value = 0
        ProgressBar1.Maximum = graph_x_span

        Dim hour_str As String
        If RadioButton_hour.Checked Then
            hour_str = TextBox_hour.Text
        Else
            hour_str = ""
        End If

        Dim dr As New data_reader
        If dr.open(date_from1, date_to1, hour_str, "raw") = 0 Then
            MsgBox("指定期間内にデータが無い")
            Exit Sub
        End If

        Dim x_axis As Double
        While True
            buf = dr.read()
            If buf(0) = "" Then
                Exit While
            End If

            ch = Double.Parse(buf(1)) + Double.Parse(buf(2))
            If ch > amp * 100 Then
                peak_find = True
                peak_seconds = peak_seconds + 2
                sum = sum + ch
            Else
                If peak_find_prev And peak_seconds > sec Then
                    x_axis = (Date.Parse(buf(3)) - date_from1).TotalSeconds / (date_to1 - date_from1).TotalSeconds * graph_x_span
                    If RadioButton_month.Checked Then ' 月表示のときだけはグラフが棒グラフなので棒の中心軸上にマークを描く
                        x_axis = Int(x_axis) + 0.5
                    End If
                    idx = Chart1.Series(4).Points.AddXY(x_axis, sum / (peak_seconds / 2))
                    Chart1.Series(4).Points(idx).Label = (peak_seconds / 60).ToString("0.0")
                    num_peak = num_peak + 1
                End If
                peak_find = False
                peak_seconds = 0
                sum = 0
            End If
            ProgressBar1.Value = Int(x_axis)
            peak_find_prev = peak_find
        End While
        ProgressBar1.Value = 0
        Label_peakcount.Text = "ピーク数:" & num_peak
    End Sub

    '----------------------------------------------------------------------------
    ' 折れ線グラフを描画する
    '
    ' 引数
    ' 　s_type - グラフの表示範囲　年:YEAR 月:MONTH 週:WEEK 日:DAY 時刻:HOUR
    '   series_no - 0:左側のカレンダーで指定された期間のグラフを描画する
    '               1:右側　　　　〃
    '   date_from,date_to - 表示期間
    '----------------------------------------------------------------------------
    Private Sub draw_series(series_no As Integer)
        Dim buf() As String
        Dim ch1 As Long
        Dim ch2 As Long
        Dim ch1_sum As Long = 0
        Dim ch2_sum As Long = 0
        Dim prev_is_0 As Boolean = False
        Dim sum_records As Long = 0
        Dim date_from As Date
        Dim date_to As Date

        If series_no = 0 Then
            date_from = date_from1
            date_to = date_to1
            Chart1.Series(0).Points.Clear()
            Chart1.Series(1).Points.Clear()
            Chart1.Series(2).Points.Clear()
            Chart1.Series(3).Points.Clear()
        Else
            date_from = date_from2
            date_to = date_to2
            Chart1.Series(2).Points.Clear()
            Chart1.Series(3).Points.Clear()
        End If
        Chart1.Series(4).Points.Clear()

        Dim datetime_step As TimeSpan ' グラフ表示の細かさはこれで制御している
        Dim graph_x_span As Double

        If RadioButton_year.Checked Then
            datetime_step = New TimeSpan(2, 0, 0, 0) ' ２日単位で集計
        End If
        If RadioButton_month.Checked Then
            datetime_step = New TimeSpan(1, 0, 0, 0) ' １日単位で集計
        End If
        If RadioButton_week.Checked Then
            datetime_step = New TimeSpan(1, 0, 0)    ' １時間単位で集計
        End If
        If RadioButton_day.Checked Then
            datetime_step = New TimeSpan(0, 5, 0)    ' ５分単位で集計
        End If
        If RadioButton_hour.Checked Then
            datetime_step = New TimeSpan(0, 0, 20)   ' ２０秒単位で集計
        End If

        graph_x_span = Chart1.ChartAreas.FindByName("ChartArea1").AxisX.Maximum

        Dim hour_str As String
        If RadioButton_hour.Checked Then
            hour_str = TextBox_hour.Text
        Else
            hour_str = ""
        End If

        Dim dr As New data_reader
        Dim file_open_extention As String
        If RadioButton_day.Checked Or RadioButton_hour.Checked Then
            file_open_extention = "raw"
        Else
            file_open_extention = "hour"
        End If

        If dr.open(date_from, date_to, hour_str, file_open_extention) = 0 Then ' データが何も無いときにダミーデータを書き込まないとグラフのマス目が表示されない
            Chart1.Series(series_no * 2 + 0).Points.AddXY(0, 0)
            Chart1.Series(series_no * 2 + 1).Points.AddXY(0, 0)
            Exit Sub
        End If

        ProgressBar1.Value = 0
        ProgressBar1.Maximum = graph_x_span

        Dim datetime_index As Date
        Dim x_axis As Double
        Dim total_ch As Double = 0
        Dim total_records As Integer = 0
        datetime_index = date_from + datetime_step
        While True
            buf = dr.read()
            total_records = total_records + 1
            If buf(0) = "" Then
                x_axis = ((((datetime_index - date_from).TotalSeconds) - (datetime_step.TotalSeconds / 2)) / (date_to - date_from).TotalSeconds) * graph_x_span
                If sum_records <> 0 Then
                    draw_point(series_no, x_axis, ch1_sum / sum_records, ch2_sum / sum_records)
                Else
                    draw_point(series_no, x_axis, 0, 0)
                End If
                Exit While
            End If

            ch1 = Long.Parse(buf(1))
            ch2 = Long.Parse(buf(2))
            total_ch = total_ch + ch1 + ch2

            If Date.Parse(buf(3)) < datetime_index Then
                ch1_sum = ch1_sum + ch1
                ch2_sum = ch2_sum + ch2
                sum_records = sum_records + 1
            Else
                x_axis = ((((datetime_index - date_from).TotalSeconds) - (datetime_step.TotalSeconds / 2)) / (date_to - date_from).TotalSeconds) * graph_x_span
                If sum_records <> 0 Then
                    draw_point(series_no, x_axis, ch1_sum / sum_records, ch2_sum / sum_records)
                Else
                    draw_point(series_no, x_axis, 0, 0)
                    prev_is_0 = True
                End If
                ch1_sum = 0
                ch2_sum = 0
                sum_records = 0
                dr.push_back()
                datetime_index = datetime_index + datetime_step
                ProgressBar1.Value = x_axis
            End If
        End While
        If series_no = 0 Then
            Label_avg1.Text = "平均：" & CInt(total_ch / total_records) & "[W]"
        Else
            Label_avg2.Text = "平均：" & CInt(total_ch / total_records) & "[W]"
        End If
        ProgressBar1.Value = 0
    End Sub

    '----------------------------------------------------------------------------
    ' グラフのデータポイントを描画する
    '----------------------------------------------------------------------------
    Private Sub draw_point(series_no As Integer, x_axis As Double, ch1 As Double, ch2 As Double)
        Dim ch1_disp As Double
        Dim ch2_disp As Double

        If CheckBox_swap.Checked Then
            ch1_disp = ch2
            ch2_disp = ch1
        Else
            ch1_disp = ch1
            ch2_disp = ch2
        End If

        If series_no = 0 Then
            If CheckBox_ch_add.Checked And CheckBox_compare.Checked Then
                Chart1.Series(0).Points.AddXY(x_axis, ch1_disp + ch2_disp)
            Else
                If CheckBox_cmp_CH1.Checked Then
                    Chart1.Series(0).Points.AddXY(x_axis, ch1_disp)
                End If
                If CheckBox_cmp_CH2.Checked Then
                    Chart1.Series(1).Points.AddXY(x_axis, ch2_disp)
                End If
            End If
        Else
            If CheckBox_ch_add.Checked And CheckBox_compare.Checked Then
                Chart1.Series(2).Points.AddXY(x_axis, ch1_disp + ch2_disp)
            Else
                If CheckBox_cmp_CH1.Checked Then
                    Chart1.Series(2).Points.AddXY(x_axis, ch1_disp)
                End If
                If CheckBox_cmp_CH2.Checked Then
                    Chart1.Series(3).Points.AddXY(x_axis, ch2_disp)
                End If
            End If
        End If
    End Sub

    '----------------------------------------------------------------------------
    ' チャートに表示されたデータをクリックしたときの処理
    '----------------------------------------------------------------------------
    Private Sub Chart1_MouseDown(sender As System.Object, e As System.Windows.Forms.MouseEventArgs) Handles Chart1.MouseDown
        Dim x_inner_position As Double   ' チャートエリアに占めるグラフの表示エリアの開始位置。値の単位は％。これはグラフのマス目だけのサイズ
        Dim x_innner_width As Double     ' チャートエリアに占めるグラフの表示エリアの割合。値の単位は％。これはグラフのマス目だけのサイズ
        Dim x_position As Double         ' Chart1のピクセルサイズに占めるチャートエリアの開始位置。値の単位は％。これは軸などを含むサイズ
        Dim x_position_width As Double   ' Chart1のピクセルサイズに占めるチャートエリアの割合。値の単位は％。これは軸などを含むサイズ
        Dim chart_width As Double        ' Chart1のピクセルサイズ

        Dim x_coordinate As Double
        Dim x_width As Double

        If CheckBox_compare.Checked Then ' 比較モードの時はチャートのクリック無効
            Exit Sub
        End If

        chart_width = Chart1.Size.Width
        x_inner_position = Chart1.ChartAreas.FindByName("ChartArea1").InnerPlotPosition.X
        x_innner_width = Chart1.ChartAreas.FindByName("ChartArea1").InnerPlotPosition.Width
        x_position = Chart1.ChartAreas.FindByName("ChartArea1").Position.X
        x_position_width = Chart1.ChartAreas.FindByName("ChartArea1").Position.Width

        x_coordinate = e.X - (x_inner_position / 100 * (x_position_width / 100 * chart_width)) - (x_position / 100 * chart_width)
        x_width = x_innner_width / 100 * (x_position_width / 100 * chart_width)

        If RadioButton_hour.Checked Then
            RadioButton_day.Checked = True
            Exit Sub
        End If

        If RadioButton_day.Checked Then
            Dim hr As Integer = Int(x_coordinate * 24 / x_width)
            If hr < 0 Or 23 < hr Then
                Exit Sub
            End If
            TextBox_hour.Text = hr.ToString("00")
            RadioButton_hour.Checked = True
            Exit Sub
        End If

        If RadioButton_week.Checked Then
            Dim day As Integer = Int(x_coordinate * 7 / x_width)
            If day < 0 Or 6 < day Then
                Exit Sub
            End If
            RadioButton_day.Checked = True
            Dim timespan1 As New TimeSpan(Integer.Parse(MonthCalendar1.SelectionRange.Start.DayOfWeek), 0, 0, 0)
            Dim timespan2 As New TimeSpan(day, 0, 0, 0)
            Dim date_from As Date
            date_from = MonthCalendar1.SelectionRange.Start - timespan1 + timespan2
            MonthCalendar1.SetDate(date_from)
        End If

        If RadioButton_month.Checked Then
            Dim day As Integer = Int(x_coordinate * 31 / x_width) + 1
            If day < 1 Or 31 < day Then
                Exit Sub
            End If
            RadioButton_day.Checked = True
            Dim calender_date As Date = MonthCalendar1.SelectionRange.Start
            MonthCalendar1.SetDate(DateSerial(calender_date.Year, calender_date.Month, day))
        End If
    End Sub

    Private Sub RadioButton_year_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton_year.CheckedChanged
        If RadioButton_year.Checked Then
            datechanged()
        End If
    End Sub

    Private Sub RadioButton_month_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton_month.CheckedChanged
        If RadioButton_month.Checked Then
            datechanged()
        End If
    End Sub

    Private Sub RadioButton_week_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton_week.CheckedChanged
        If RadioButton_week.Checked Then
            datechanged()
        End If
    End Sub

    Private Sub RadioButton_day_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton_day.CheckedChanged
        If RadioButton_day.Checked Then
            MonthCalendar1.SetDate(MonthCalendar1.SelectionRange.Start)
            MonthCalendar2.SetDate(MonthCalendar2.SelectionRange.Start)
            datechanged()
        End If
    End Sub

    Private Sub RadioButton_hour_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles RadioButton_hour.CheckedChanged
        If RadioButton_hour.Checked Then
            datechanged()
        End If
    End Sub

    Private Sub Button_update_Click(sender As System.Object, e As System.EventArgs) Handles Button_update.Click
        process_raw()
        datechanged()
    End Sub

    '----------------------------------------------------------------------------
    ' １ヶ月の日数は一定では無いので月境界の位置は少しずれる
    '----------------------------------------------------------------------------
    Private Sub display_graph_year()
        Dim month As Integer
        Dim tdate As Date

        tdate = MonthCalendar1.SelectionRange.Start
        date_from1 = DateSerial(tdate.Year, 1, 1)
        date_to1 = DateSerial(tdate.Year, 12, 31)
        tdate = MonthCalendar2.SelectionRange.Start
        date_from2 = DateSerial(tdate.Year, 1, 1)
        date_to2 = DateSerial(tdate.Year, 12, 31)

        With Chart1.ChartAreas.FindByName("ChartArea1").AxisX
            .Interval = 1
            .Minimum = 0
            .Maximum = 12
            .Title = "月"
            .CustomLabels.Clear()
            For month = 1 To 12
                .CustomLabels.Add(month - 1, month, month.ToString)
            Next
        End With

        display_graph()
    End Sub

    '----------------------------------------------------------------------------
    ' １ヶ月の日数が異なるので処理はやや複雑になる
    '----------------------------------------------------------------------------
    Private Sub display_graph_month()
        Dim adays As New TimeSpan(23, 59, 59)
        Dim tdate As Date
        Dim ts As New TimeSpan(1, 0, 0, 0)

        tdate = MonthCalendar1.SelectionRange.Start
        date_from1 = DateSerial(tdate.Year, tdate.Month, 1)
        date_to1 = DateSerial(tdate.Year, tdate.Month + 1, 1) - ts + adays
        tdate = MonthCalendar2.SelectionRange.Start
        date_from2 = DateSerial(tdate.Year, tdate.Month, 1)
        date_to2 = DateSerial(tdate.Year, tdate.Month + 1, 1) - ts + adays
        Dim total_days As Integer

        If CheckBox_compare.Checked Then
            total_days = Math.Max(date_to1.Day, date_to2.Day)
        Else
            total_days = date_to1.Day
        End If

        Dim day As Integer
        With Chart1.ChartAreas.FindByName("ChartArea1").AxisX
            .Interval = 1
            .Minimum = 0
            .Maximum = total_days
            .Title = "日"
            .CustomLabels.Clear()
            For day = 1 To total_days
                .CustomLabels.Add(day - 1, day, day.ToString)
            Next
        End With

        display_graph()
    End Sub

    Private Sub display_graph_week()
        Dim adays As New TimeSpan(23, 59, 59)
        Dim timespan As TimeSpan

        timespan = New TimeSpan(Integer.Parse(MonthCalendar1.SelectionRange.Start.DayOfWeek), 0, 0, 0)
        date_from1 = MonthCalendar1.SelectionRange.Start - timespan
        timespan = New TimeSpan(Integer.Parse(MonthCalendar2.SelectionRange.Start.DayOfWeek), 0, 0, 0)
        date_from2 = MonthCalendar2.SelectionRange.Start - timespan
        timespan = New TimeSpan(6, 0, 0, 0)
        date_to1 = date_from1 + timespan + adays
        date_to2 = date_from2 + timespan + adays

        With Chart1.ChartAreas.FindByName("ChartArea1").AxisX
            .Interval = 1
            .Minimum = 0
            .Maximum = 7
            .Title = "曜日"
            .CustomLabels.Clear()
            .CustomLabels.Add(0, 1, "日")
            .CustomLabels.Add(1, 2, "月")
            .CustomLabels.Add(2, 3, "火")
            .CustomLabels.Add(3, 4, "水")
            .CustomLabels.Add(4, 5, "木")
            .CustomLabels.Add(5, 6, "金")
            .CustomLabels.Add(6, 7, "土")
        End With

        display_graph()
    End Sub

    Private Sub display_graph_day()
        Dim adays As New TimeSpan(23, 59, 59)
        date_from1 = MonthCalendar1.SelectionRange.Start
        date_to1 = date_from1 + adays
        date_from2 = MonthCalendar2.SelectionRange.Start
        date_to2 = date_from2 + adays

        With Chart1.ChartAreas.FindByName("ChartArea1").AxisX
            .Interval = 1
            .Minimum = 0
            .Maximum = 24
            .Title = "時刻"
            .CustomLabels.Clear()
            For hr = 0 To 24
                .CustomLabels.Add(hr - 0.5, hr + 0.5, hr.ToString)
            Next
        End With

        display_graph()
    End Sub

    Private Sub display_graph_hour()
        Dim hspan1 As TimeSpan
        Dim hspan2 As TimeSpan
        hspan1 = New TimeSpan(CInt(TextBox_hour.Text), 0, 0)
        hspan2 = New TimeSpan(0, 59, 59)
        date_from1 = MonthCalendar1.SelectionRange.Start + hspan1
        date_to1 = date_from1 + hspan2
        date_from2 = MonthCalendar2.SelectionRange.Start + hspan1
        date_to2 = date_from2 + hspan2

        With Chart1.ChartAreas.FindByName("ChartArea1").AxisX
            .Interval = 1
            .Minimum = 0
            .Maximum = 60
            .Title = "分"
            .CustomLabels.Clear()
            For mn = 0 To 60
                If mn Mod 5 = 0 Then
                    .CustomLabels.Add(mn - 0.5, mn + 0.5, mn.ToString)
                End If
            Next
        End With

        display_graph()
    End Sub

    '----------------------------------------------------------------------------
    ' 日付.txt ファイルを集計してＣＳＶファイルを生成する
    '----------------------------------------------------------------------------
    Private Sub Button_csv_Click(sender As System.Object, e As System.EventArgs) Handles Button_csv.Click
        Dim buf() As String = {""}
        Dim sum_ch1_d, sum_ch2_d As Long
        Dim min_ch1_d, min_ch2_d, min_add_d As Long
        Dim max_ch1_d, max_ch2_d, max_add_d As Long
        Dim avg_ch1_d, avg_ch2_d, avg_add_d As Long
        Dim records_d As Integer
        Dim sum_ch1_h, sum_ch2_h As Long
        Dim min_ch1_h, min_ch2_h, min_add_h As Long
        Dim max_ch1_h, max_ch2_h, max_add_h As Long
        Dim avg_ch1_h, avg_ch2_h, avg_add_h As Long
        Dim records_h As Integer
        Dim ch1 As Long
        Dim ch2 As Long
        Dim ch_add As Long
        Dim out_str As String
        Dim key As String
        Dim key_prev As String = ""
        Dim out_file_date As System.IO.StreamWriter
        Dim out_file_hour As System.IO.StreamWriter

        out_file_date = My.Computer.FileSystem.OpenTextFileWriter(data_path & "agv_date.csv", False, System.Text.Encoding.ASCII)
        out_file_hour = My.Computer.FileSystem.OpenTextFileWriter(data_path & "agv_hour.csv", False, System.Text.Encoding.ASCII)
        Dim comment_txt As String = ",min(CH1),avg(CH1),max(CH1),min(CH2),avg(CH2),max(CH2),min(CH1+CH2),avg(CH1+CH2),max(CH1+CH2)"
        out_file_date.WriteLine(comment_txt)
        out_file_hour.WriteLine(comment_txt)

        Dim files As String() = System.IO.Directory.GetFiles(data_path, "2???????.txt")
        Array.Sort(files)
        ProgressBar1.Value = 0
        ProgressBar1.Maximum = files.Count

        Dim file_in As FileIO.TextFieldParser
        records_h = 0
        sum_ch1_h = 0
        sum_ch2_h = 0
        max_ch1_h = 0
        max_ch2_h = 0
        max_add_h = 0
        min_ch1_h = Long.MaxValue
        min_ch2_h = Long.MaxValue
        min_add_h = Long.MaxValue
        For Each fname In files
            ProgressBar1.Value = ProgressBar1.Value + 1
            file_in = My.Computer.FileSystem.OpenTextFieldParser(fname, ",")
            records_d = 0
            sum_ch1_d = 0
            sum_ch2_d = 0
            max_ch1_d = 0
            max_ch2_d = 0
            max_add_d = 0
            min_ch1_d = Long.MaxValue
            min_ch2_d = Long.MaxValue
            min_add_d = Long.MaxValue

            While Not file_in.EndOfData
                buf = file_in.ReadFields
                ch1 = Long.Parse(buf(1))
                ch2 = Long.Parse(buf(2))
                ch_add = ch1 + ch2
                sum_ch1_d = sum_ch1_d + ch1
                sum_ch2_d = sum_ch2_d + ch2
                max_ch1_d = System.Math.Max(ch1, max_ch1_d)
                max_ch2_d = System.Math.Max(ch2, max_ch2_d)
                max_add_d = System.Math.Max(ch_add, max_add_d)
                min_ch1_d = System.Math.Min(ch1, min_ch1_d)
                min_ch2_d = System.Math.Min(ch2, min_ch2_d)
                min_add_d = System.Math.Min(ch_add, min_add_d)
                records_d = records_d + 1

                key = Mid(buf(3), 1, 13)
                If key <> key_prev And key_prev <> "" Then
                    avg_ch1_h = sum_ch1_h / records_h
                    avg_ch2_h = sum_ch2_h / records_h
                    avg_add_h = (sum_ch1_h + sum_ch2_h) / records_h
                    out_str = key_prev & ":00:00,"
                    out_str = out_str + min_ch1_h.ToString & "," + avg_ch1_h.ToString & "," + max_ch1_h.ToString & ","
                    out_str = out_str + min_ch2_h.ToString & "," + avg_ch2_h.ToString & "," + max_ch2_h.ToString & ","
                    out_str = out_str + min_add_h.ToString & "," + avg_add_h.ToString & "," + max_add_h.ToString
                    out_file_hour.WriteLine(out_str)
                    records_h = 0
                    sum_ch1_h = 0
                    sum_ch2_h = 0
                    max_ch1_h = 0
                    max_ch2_h = 0
                    max_add_h = 0
                    min_ch1_h = Long.MaxValue
                    min_ch2_h = Long.MaxValue
                    min_add_h = Long.MaxValue
                End If
                key_prev = key
                sum_ch1_h = sum_ch1_h + ch1
                sum_ch2_h = sum_ch2_h + ch2
                max_ch1_h = System.Math.Max(ch1, max_ch1_h)
                max_ch2_h = System.Math.Max(ch2, max_ch2_h)
                max_add_h = System.Math.Max(ch_add, max_add_h)
                min_ch1_h = System.Math.Min(ch1, min_ch1_h)
                min_ch2_h = System.Math.Min(ch2, min_ch2_h)
                min_add_h = System.Math.Min(ch_add, min_add_h)
                records_h = records_h + 1
            End While
            avg_ch1_d = sum_ch1_d / records_h
            avg_ch2_d = sum_ch2_d / records_h
            avg_add_d = (sum_ch1_d + sum_ch2_d) / records_h
            out_str = Mid(buf(3), 1, 10) & ","
            out_str = out_str + min_ch1_d.ToString & "," + avg_ch1_d.ToString & "," + max_ch1_d.ToString & ","
            out_str = out_str + min_ch2_d.ToString & "," + avg_ch2_d.ToString & "," + max_ch2_d.ToString & ","
            out_str = out_str + min_add_d.ToString & "," + avg_add_d.ToString & "," + max_add_d.ToString
            out_file_date.WriteLine(out_str)
            file_in.Close()
        Next
        out_file_date.Close()
        out_file_hour.Close()
        ProgressBar1.Value = 0
    End Sub

    Private Sub MonthCalendar1_DateChanged(sender As System.Object, e As System.Windows.Forms.DateRangeEventArgs) Handles MonthCalendar1.DateChanged
        datechanged()
    End Sub

    Private Sub MonthCalendar2_DateChanged(sender As System.Object, e As System.Windows.Forms.DateRangeEventArgs) Handles MonthCalendar2.DateChanged
        datechanged()
    End Sub

    Private Sub datechanged()
        If RadioButton_hour.Checked Then
            display_graph_hour()
        End If
        If RadioButton_day.Checked Then
            display_graph_day()
        End If
        If RadioButton_week.Checked Then
            display_graph_week()
        End If
        If RadioButton_month.Checked Then
            display_graph_month()
        End If
        If RadioButton_year.Checked Then
            display_graph_year()
        End If
    End Sub

    Private Sub CheckBox_fixedY_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_fixedY.CheckedChanged
        If CheckBox_fixedY.Checked Then
            Ymax = Chart1.ChartAreas(0).AxisY.Maximum
        Else
            Chart1.ChartAreas(0).AxisY.Maximum = Double.NaN
        End If
    End Sub

    Private Sub CheckBox_cmp_CH1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_cmp_CH1.CheckedChanged
        If CheckBox_cmp_CH1.Checked = False And CheckBox_cmp_CH2.Checked = False Then
            CheckBox_cmp_CH2.Checked = True
        Else
            If CheckBox_compare.Checked Then
                datechanged()
            End If
        End If
    End Sub

    Private Sub CheckBox_cmp_CH2_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_cmp_CH2.CheckedChanged
        If CheckBox_cmp_CH1.Checked = False And CheckBox_cmp_CH2.Checked = False Then
            CheckBox_cmp_CH1.Checked = True
        Else
            If CheckBox_compare.Checked Then
                datechanged()
            End If
        End If
    End Sub

    Private Sub CheckBox_compare_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_compare.CheckedChanged
        If CheckBox_compare.Checked Then
            CheckBox_swap.Checked = False
            CheckBox_swap.Enabled = False
            CheckBox_cmp_CH1.Enabled = True
            CheckBox_cmp_CH2.Enabled = True
            CheckBox_ch_add.Enabled = True
            SplitContainer2.Visible = True
            MonthCalendar2.Visible = True
            GroupBox_peak.Enabled = False
        Else
            CheckBox_swap.Enabled = True
            CheckBox_cmp_CH1.Checked = True
            CheckBox_cmp_CH2.Checked = True
            CheckBox_cmp_CH1.Enabled = False
            CheckBox_cmp_CH2.Enabled = False
            CheckBox_ch_add.Enabled = False
            SplitContainer2.Visible = False
            MonthCalendar2.Visible = False
            GroupBox_peak.Enabled = True
        End If
        datechanged()
    End Sub

    Private Sub CheckBox_ch_add_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_ch_add.CheckedChanged
        If CheckBox_ch_add.Checked Then
            CheckBox_cmp_CH1.Enabled = True
            CheckBox_cmp_CH2.Enabled = True
            CheckBox_cmp_CH1.Enabled = False
            CheckBox_cmp_CH2.Enabled = False
        Else
            CheckBox_cmp_CH1.Enabled = False
            CheckBox_cmp_CH2.Enabled = False
            CheckBox_cmp_CH1.Enabled = True
            CheckBox_cmp_CH2.Enabled = True
        End If
        datechanged()
    End Sub

    Private Sub CheckBox_swap_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CheckBox_swap.CheckedChanged
        datechanged()
    End Sub

    Private Sub TrackBar_amp_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar_amp.Scroll
        TrackBar_amp.Value = CInt((TrackBar_amp.Value + 2.0) / 5) * 5
        timelabel()
    End Sub

    Private Sub TrackBar_time_Scroll(sender As System.Object, e As System.EventArgs) Handles TrackBar_time.Scroll
        TrackBar_time.Value = CInt((TrackBar_time.Value + 4) / 10) * 10
        timelabel()
    End Sub

    Private Sub timelabel()
        Dim limit_threshold_time = New TimeSpan(Long.Parse(TrackBar_time.Value) * 10000000)
        Label_limit.Text = TrackBar_amp.Value.ToString & "A  " & limit_threshold_time.ToString("m\分ss\秒")
    End Sub

    Private Sub Button_peak_Click(sender As System.Object, e As System.EventArgs) Handles Button_peak.Click
        draw_peak()
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        Label_version.Text = System.String.Format("Ver {0}.{1}.{2:00}", _
                   My.Application.Info.Version.Major, My.Application.Info.Version.Minor, My.Application.Info.Version.Build)
        datechanged()
    End Sub

End Class

'----------------------------------------------------------------------------
' 指定期間のファイルを読み込み日付、時刻順にレコードを返す
'----------------------------------------------------------------------------
Public Class data_reader
    Private data_path As String = System.AppDomain.CurrentDomain.BaseDirectory & "\data\"
    Private file_list As New List(Of String)
    Private fd As FileIO.TextFieldParser
    Private file_index As Integer
    Private hour_display As Boolean
    Private hour_value As String
    Private buf_full As Boolean
    Private buf As String()

    Public Sub New()
        hour_display = False
        buf_full = False
    End Sub

    '----------------------------------------------------------------------------
    ' 一度読み込んだレコードを返却する。次にread()を呼ぶと返却した物が返ってくる
    '----------------------------------------------------------------------------
    Public Sub push_back()
        buf_full = True
    End Sub

    '----------------------------------------------------------------------------
    ' 対象期間のファイル一覧を生成し、日付の古い最初のファイルをopenする
    '----------------------------------------------------------------------------
    Public Function open(from_date As Date, to_date As Date, hour_string As String, file_open_extention As String) As Integer
        Dim tmp_fname As String
        Dim date_index As Date
        Dim date_step As New TimeSpan(1, 0, 0, 0)
        Dim number_of_files As Integer

        If hour_string <> "" Then
            hour_value = hour_string
            hour_display = True
        End If

        Dim file_ext As String
        If file_open_extention = "raw" Then
            file_ext = ".txt"
        Else
            file_ext = ".txt2"
        End If

        number_of_files = 0
        date_index = from_date
        While date_index <= to_date
            tmp_fname = data_path & date_index.ToString("yyyyMMdd") & file_ext
            date_index = date_index + date_step
            If System.IO.File.Exists(tmp_fname) Then
                file_list.Add(tmp_fname)
                number_of_files = number_of_files + 1
            End If
        End While

        file_list.Sort()

        If number_of_files > 0 Then
            fd = My.Computer.FileSystem.OpenTextFieldParser(file_list(0), ",")
            file_index = 1
        End If

        Return number_of_files
    End Function



    '----------------------------------------------------------------------------
    ' １行読み込む　読み込んだレコードは","で分割された文字列の配列として返す
    '----------------------------------------------------------------------------
    Public Function read() As String()
        If buf_full Then
            buf_full = False
            Return buf
        End If
        Do
            If fd.EndOfData Then
                fd.Close()
                If file_index < file_list.Count Then
                    fd = My.Computer.FileSystem.OpenTextFieldParser(file_list(file_index), ",")
                    file_index = file_index + 1
                Else
                    Return {"", "", "", ""}
                End If
            End If

            buf = fd.ReadFields
            If hour_display Then
                If Mid(buf(3), 12, 2) = hour_value Then
                    Return buf
                End If
            Else
                Return buf
            End If
        Loop
    End Function
End Class

'---------------- プログラム終わり ------------------------------------



